/*# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
#                        pour la Sant�)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
# Previous Authors : Laurent Guigues, Jean-Pierre Roux
# CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
#
#  This software is governed by the CeCILL-B license under French law and
#  abiding by the rules of distribution of free software. You can  use,
#  modify and/ or redistribute the software under the terms of the CeCILL-B
#  license as circulated by CEA, CNRS and INRIA at the following URL
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability.
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------ */



#include "listWx.h"

namespace creaButtonContainer
{
	namespace view
	{
		// ----------------------------------------------------------------------------------
		ListWx::ListWx( wxWindow* parent, wxWindowID id,ItemsMap iMap , TFunctor* functor ): wxListCtrl(parent,id)
		{

			std::cout<< "MLER | ListWx::ListWx()" << std::endl;
			this->m_itemsMap = iMap;

			this->functor = functor;
			int i = 0;
			for (ItemsMap::iterator it=this->m_itemsMap.begin(); it!=this->m_itemsMap.end(); ++it)
			{

				std::string key = it->first;
				long index = this->InsertItem(i, wxString(key.c_str(), wxConvUTF8));

				std::cout << "index" << index << std::endl;
				this->Connect( -1, wxEVT_COMMAND_LIST_ITEM_SELECTED,
						 wxListEventHandler(ListWx::ListEvent) );
				i++;
			}
		}

		// ----------------------------------------------------------------------------------
		ListWx::~ListWx( )
		{
		}

		void
		ListWx::ListEvent( wxListEvent& event )
		{
			try
			{
				std::cout<< "MLER | ListWx::ListEvent( wxListEvent& event )" << std::endl;

				wxString itemNom = event.GetItem().GetText();

				std::string itemNomC = std::string(itemNom.mb_str());

				this->functor->Call(itemNomC);
				std::cout<<"mmmmmmmmmmmmmmmmmmmmmmm"<<std::endl;

			}//yrt
			catch ( const std::exception& e )
			{
				std::cerr
				    << "ButtonContainerController::ButtonEvent( wxCommandEvent& event ) exception: "
				    << e.what( ) << std::endl;
			}//hctac
		}
	// ----------------------------------------------------------------------------------
	}//ecapseman
}//ecapseman


