/*# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
#                        pour la Sant�)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
# Previous Authors : Laurent Guigues, Jean-Pierre Roux
# CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
#
#  This software is governed by the CeCILL-B license under French law and
#  abiding by the rules of distribution of free software. You can  use,
#  modify and/ or redistribute the software under the terms of the CeCILL-B
#  license as circulated by CEA, CNRS and INRIA at the following URL
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability.
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------ */

/*!
 * @file creaPanelButtonContainer.h
 * @brief implements PanelButtonContainer class
 * @author Diego CACERES (diego.caceres[AT]creatis.insa-lyon.fr)
 * @date  2011-06-02
 */

#include "creaPanelButtonContainer.h"


namespace creaPanelButtonContainer
{
	BEGIN_EVENT_TABLE(PanelButtonContainer,wxPanel)
		//EVT_LIST_ITEM_SELECTED(-1, ListWx::ListEvent)

	//(*EventTable(ButtonContainerPanel)
	//*)
	END_EVENT_TABLE()
	// ----------------------------------------------------------------------------------
	typedef creaButtonContainer::model::TConcreteFunctor< PanelButtonContainer >   TConcreteFunctor;
	// ----------------------------------------------------------------------------------
	PanelButtonContainer::PanelButtonContainer( wxWindow* parent,  ButtonContainerSettings* bcSettings, int type )
		: wxPanel( parent, -1, wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("creaPanelButtonContainer") )
	{
		std::cout<< "MLER | creaPanelButtonContainer:: PanelButtonContainer() " << std::endl;

		this->m_ButtonContainerSettings = bcSettings;
		this->m_ButtonPanel = new wxPanel( this );

		//Class that manages the event!!!
	//EED 20/01/2012
		TConcreteFunctor* functor = new TConcreteFunctor( this, &PanelButtonContainer::GenericButtonEvent );
//		TConcreteFunctor* functor = new TConcreteFunctor( this->m_ButtonPanel, &PanelButtonContainer::GenericButtonEvent );
		//end of the event definition

		TConcreteFunctor* lFunctor = new TConcreteFunctor( this, &PanelButtonContainer::GenericListEvent );
		//MLER

		this->m_ListPanel = new wxPanel(this);

		if(type == 0)
		{
			std::cout << "tipo 0; new ButtonContainerPanel"<<std::endl;
			this->m_ButtonContainerPanel = new ButtonContainerPanel( this, this->m_ButtonContainerSettings->GetButtonGroupSettings( functor ),type );
		}
//		else if( type == 1)
//		{
//			std::cout << "tipo 1; new LIstWx"<<std::endl;
//			this->mylist = new ListWx(this->m_ListPanel, -1,this->m_ButtonContainerSettings->GetItemsMap(), lFunctor);
//		}//MLER


		//Using AuiManager to Manage the Panels
		this->m_AuiManager = new wxAuiManager( this, wxAUI_MGR_DEFAULT );

		if(type == 0)
			this->m_AuiManager->AddPane(this->m_ButtonContainerPanel, wxAuiPaneInfo( ).Name( _T("ButtonPanel") ).Caption( _("Panel") ). CaptionVisible(true ).CloseButton( false ).Bottom( ).Resizable( true ) );
		else if(type == 1)
			this->m_AuiManager->AddPane(this->m_ListPanel, wxAuiPaneInfo( ).Name( _T("ListPanel") ).Caption( _("Panel") ). CaptionVisible(true ).CloseButton( false ).Bottom( ).Resizable( true ) );

		//CartoButtonPanel Management
		if(type == 0)
			this->m_AuiManager->AddPane( this->m_ButtonContainerPanel,wxAuiPaneInfo( ).Name( _T("ButtonPanel") ).Caption(_("ListPanel") ). CaptionVisible( false ).CloseButton(false ).Center( ).Resizable( true ) );
		else if(type ==1)
			{this->m_AuiManager->AddPane( this->m_ListPanel,wxAuiPaneInfo( ).Name( _T("ListPanel") ).Caption(_("ListPanel") ). CaptionVisible( false ).CloseButton(false ).Center( ).Resizable( true ) );}
		this->m_AuiManager->Update( );
	}
	// ----------------------------------------------------------------------------------
	PanelButtonContainer::~PanelButtonContainer( )
	{
	}
	// ----------------------------------------------------------------------------------
	void
	PanelButtonContainer::UpdatePanel( const std::string &buttonName )
	{
		try
		{
			std::cout<< "MLER | creaPanelButtonContainer:: UpdatePanel() " << std::endl;

			//Hiding the last CartoSettingsPanel
			this->m_ButtonPanel->Show( false );
			//Finding the CartoSettingsPanel of the ButtonClicket
			this->m_ButtonPanel = this->m_ButtonContainerSettings->GetPanelButton(buttonName );
			std::cout<< buttonName << "---testEvento 2 "<<std::endl;
			//changing the parent of the panel!
			if ( this->m_ButtonPanel->GetParent( ) != this )
			{
				this->m_ButtonPanel->Reparent( this );
			}//fi
			//Panel Management
			this->m_AuiManager->GetPane( _T("ButtonPanel") ).window = this->m_ButtonPanel;
			//Updating the manager
			this->m_AuiManager->Update( );
		}//yrt
		catch ( const std::exception& e )
		{
			std::cerr
			    << "PanelButtonContainer::UpdatePanel( const std::string &buttonName )"
			    << "exception: " << e.what( ) << std::endl;
			std::cout << "Maybe the panel of the button is NULL" << std::endl;
			exit( 1 );
		}//hctac
	}
	// ----------------------------------------------------------------------------------
	void
	PanelButtonContainer::GenericButtonEvent( const std::string &buttonName )
	{
		std::cout<< "MLER | creaPanelButtonContainer:: GenericButtonEvent() " << std::endl;
		std::cout<< buttonName << "---testEvento 1 "<<std::endl;
		this->UpdatePanel( buttonName );
	}
// ----------------------------------------------------------------------------------

/*
	void
	PanelButtonContainer::UpdateListPanel( const std::string &buttonName )
	{
		try{

			std::cout<< "MLER | creaPanelButtonContainer:: UpdateListPanel() " << std::endl;
			std::cout<< buttonName << " --- test 2 "<<std::endl;

			this->m_ListPanel->Show( false );

			this->m_ListPanel = this->m_ButtonContainerSettings->GetPanelList(buttonName );

			if ( this->m_ListPanel->GetParent( ) != this )
			{
				this->m_ListPanel->Reparent( this );
			}//fi
						//Panel Management
			this->m_AuiManager->GetPane( _T("ListPanel") ).window = this->m_ListPanel;
						//Updating the manager
			this->m_AuiManager->Update( );

		}catch( const std::exception& e )
		{
			std::cerr
			    << "PanelButtonContainer::UpdatePanel( const std::string &buttonName )"
			    << "exception: " << e.what( ) << std::endl;
			std::cout << "Maybe the panel of the list is NULL" << std::endl;
			exit( 1 );
		}//hctac
	}
*/
	void
	PanelButtonContainer::GenericListEvent( const std::string &buttonName )
	{
		std::cout<< "MLER | creaPanelButtonContainer:: GenericListEvent() " << std::endl;
		std::cout<< buttonName << " --- test 3 "<<std::endl;
		this->UpdateListPanel( buttonName );
	}


}//ecapseman


