/*# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
#                        pour la Sant�)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
# Previous Authors : Laurent Guigues, Jean-Pierre Roux
# CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
#
#  This software is governed by the CeCILL-B license under French law and
#  abiding by the rules of distribution of free software. You can  use,
#  modify and/ or redistribute the software under the terms of the CeCILL-B
#  license as circulated by CEA, CNRS and INRIA at the following URL
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability.
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------ */

/*=========================================================================

  Program:   wxMaracas
  Module:    $RCSfile: marObject.cpp,v $
  Language:  C++
  Date:      $Date: 2012/11/15 14:16:12 $
  Version:   $Revision: 1.3 $

  Copyright: (c) 2002, 2003
  License:
  
     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notice for more information.

=========================================================================*/

#include "marObject.h"

// -------------------------------------------------------------------------
marObject::marObject( marParameters* p )
{
    _parameters = p;
    _parametersCopied = false;
}

// -------------------------------------------------------------------------
marObject::~marObject( )
{
    if( _parametersCopied && _parameters != NULL ) delete _parameters;
}

// -------------------------------------------------------------------------
void marObject::setParameters( marParameters* p )
{
    if( _parametersCopied && _parameters != NULL ) delete _parameters;
    _parameters = p;
    _parametersCopied = false;
}

// -------------------------------------------------------------------------
void marObject::copyParameters( marParameters* p )
{
    if( _parametersCopied && _parameters != NULL ) delete _parameters;
    _parameters = new marParameters( );
    *_parameters = *p;
    _parametersCopied = true;
}

// -------------------------------------------------------------------------
bool marObject::save( std::string& nw )
{
    std::ofstream os( nw.c_str( ) );

    if( os ) {

	save( os );
	os.close( );
	return( true );

    } // fi

    return( false );
}

// -------------------------------------------------------------------------
bool marObject::load( std::string& nr )
{
    std::ifstream is( nr.c_str( ) );

    if( is ) {

	load( is );
	is.close( );
	return( true );

    } // fi

    return( false );
}

// eof - object.cxx
